*************************************************************
*************************************************************
****                                                     ****
****       C L A V I E R        T  O    9 +              ****
****                                                     ****
*************************************************************
*************************************************************
*                                                           *
* Microprocesseurs   6805 P2, RAM  64, ROM 1100, 28 broches *
*                   68705 P3, RAM 112, ROM 1804, 28 broches *
*
*************************************************************
*                                                           *
* Version du :  24  JANVIER  1986         *   fichier CLO   *
*                                                           *
* POUR MASQUAGE
*************************************************************
*
* ADRESSES PROGRAMME EN ROM
PROG   EQU    $3C0     6805 P2, FIN ROM EN $783
*PROG   EQU    $100     68705 P3, FIN ROM EN $783
*PROG   EQU    $100     68705 U2, FIN DE ROM EN $F37
TAB1   EQU    $80      ROM EN PAGE 0
*************************************************************
* CONSTANTES TIMER ( PRE-DIVISEUR /32 )
TCRON  EQU    $15      INTERRUPTION TIMER AUTORISEE
TCROFF EQU    $55      INTERRUPTION TIMER INTERDITE
TCRZ   EQU    $5D      PRE-DIVISEUR A ZERO
MOR    EQU    $45      MASK OPTION REGISTER SUR 68705
**********************
* CONSTANTES DIVERSES
TCAPS  EQU    48       POSITION DANS LA MATRICE
*************************************************************
* MEMOIRE RAM          ( 32 OCTETS DISPONIBLES )
       ORG    $40      FIN RAM EN $5F (PILE DE $60 A $7F)
DRAM   EQU    *
FRAM   EQU    $5F
*
EXP    RMB    1        TYPE DU CLAVIER, FRANCAIS=0, EXPORT<>0
CODE1  RMB    1        CODE APRES SCRUTATION MATRICE
CODE2  RMB    1
CODE11 RMB    1
CODEF  RMB    1        CODE FINAL A ENVOYER
COL    RMB    1        COLONNE DE LA MATRICE
COL2   RMB    1
MINMAJ RMB    1        CODE MINUSCULE/MAJUSCULE ET PERIPHERIQUE
MM     RMB    1        INDICATEUR MIN/MAJ, SAUVEGARDE PORT B
MMP    RMB    1        VALEUR PRECEDENTE DE MINMAJ
HEX    RMB    1        TEMPORAIRE EN MODE HEXA
TEMP   RMB    1        TEMPORAIRE (SCR)
TEMP2  RMB    1        TEMPORAIRE (SCR)
COMPT  RMB    1        COMPTEUR DES 8 BITS, SORTIE SERIE
C1000  RMB    1        CONSTANTE D'ATTENTE REPETITION
C70    RMB    1        CONSTANTE DE CADENCE REPETITION
CREP1  RMB    1        COMPTEUR DELAI REPETITION 0.8 SECONDE
CREP70 RMB    1        COMPTEUR DELAI REPETITION 70 MILLI-SECONDE
SA     RMB    1        SAUVEGARDE A POUR TEMPORISATIONS
PCC    RMB    1        SAUVEGARDE DU PORT C ( ROTATIONS )
*************************************************************
*  INDICATEURS
INDIC  RMB    1        BIT 7= AUTORISATION D'ENVOI DU CODE CLAVIER
*                      BIT 6= UNE TOUCHE VALIDE PRESSEE
*                      BIT 5= TOUCHE VERROUILLAGE PRESSEE
*                      BIT 4= MODE HEXA-DECIMAL
*                      BIT 3=
*                      BIT 2= CODE 1 ENVOYE
*                      BIT 1= DEUX TOUCHES DETECTEES (SCR)
*                      BIT 0= UNE TOUCHE DETECTEE (SCR)
*
MODE   RMB    1        BIT 5= MODE VT100
*                      BIT 0= MIN EN SHIFT CAPS
*
SC     RMB    1        BIT 1= TOUCHE SHIFT ENFONCEE
*                      BIT 0= TOUCHE CONTROLE ENFONCEE
*************************************************************
* ENTREES/SORTIES
       ORG    0
PA     RMB    1
PB     RMB    1
PC     RMB    1
       RMB    1
CLAV   EQU    PA
DIRA   RMB    1
DIRB   RMB    1
DIRC   RMB    1
       RMB    1
TIMER  RMB    1
TCR    RMB    1
       RMB    1
PCREG  RMB    1        (SUR 68705 UNIQUEMENT)
*************************************************************
* PORT A : ENTREE DES 8 LIGNES DE LA MATRICE DES TOUCHES
*               A7    = SELECTION FRANCAIS/EXPORT AU RESET
***************
* PORT B : SORTIES VERS LES LIGNES DE LA MATRICE (L1 a L8)
*               B7    = COMMANDE DE LA LED  CAPS
*               B6    = ENTRE TOUCHE SHIFT
*               B5    = ENTREE TOUCHE CONTROLE
*               B2    = ENTREE FRANCAIS/EXPORT
LED    EQU    7
SHIFT  EQU    6
CNTRL  EQU    5
FRAEXP EQU    2
***************
* PORT C :      C0,C1 = SCRUTATION DE LA MATRICE ( L9, L10 )
*               C1    = SORTIE DONNEE SERIE
*               C2    = SORTIE KTEST
*               C3    = SORTIE HORLOGE (liaison serie synchrone)
SD     EQU    1
KT     EQU    2
H      EQU    3
*************************************************************
* MASK OPTION
*       ORG    $F38     68705 U3 (OU R3)
*      ORG    $784     68705 P3
*      FCB    MOR
*************************************************************
*POINTEURS
*       ORG    $FF8     68705 U3, 68 P 05 V 07
       ORG    $7F8     6805 P2, 68705 P3
       FDB    INTTIM   INTERRUPTION TIMER
       FDB    INT      INTERRUPTION EXTERNE
       FDB    INIT     SWI (NON UTILISE)
       FDB    INIT     RESET
*************************************************************
* FONCTIONS SPECIALES
*  OBTENUES PAR APPUI SUR LES TOUCHES CNTRL ET SHIFT
*  PUIS APPUI MOMENTANE SUR LA TOUCHE CAPS
*  ET ENFIN APPUI SUR LA TOUCHE SELON LA FONCTION DESIREE
*
*  TOUCHE    F : CLAVIER FRANCAIS
*            E : CLAVIER EXPORT
*            V : PAVE NUMERIQUE VT100
*            N : PAVE NUMERIQUE NORMAL
*            M : MINUSCULES EN SHIFT CAPS
*          RAZ : MINUSCULES NORMALES
*    FONCTIONS : ATTENTE REPETITION (0,4 A 1,6 SECONDES )
*   LIGNE NUM. : CADENCE REPETITION (10 A 100 MS )
*    PAVE NUM. : COMMANDES UNITE CENTRALE (0 A 5 )
*************************************************************
* FONCTION HEXA-DECIMALE
* ENVOI D'UN CODE QUELCONQUE COMPRIS ENTRE $00 ET $FF
*  OBTENUE PAR APPUI SUR LA TOUCHE CNTRL
*  PUIS APPUI MOMENTANE SUR LA TOUCHE CAPS
*  ET ENFIN APPUI SUR LES 2 TOUCHES HEXA-DECIMALES
*  ( TOUCHES 0...9 DU PAVE, 0...9 A,B,C,D,E,F )
*************************************************************
*************************************************************
*  CLAVIER TO 9+  ***  24 JANVIER 1986  ***  FICHIER CL1  ***
*************************************************************
       ORG    PROG
*
* MISE A ZERO DE TOUTE LA RAM
INIT   LDX    #DRAM
IN2    CLR    0,X
       INCX
       CPX    #FRAM+1
       BNE    IN2
* INITIALISATION DES PORTS
       LDA    #$FF
       STA    DIRB      PORT B= SORTIES
       LDA    #$0F      PORT C= SORTIES ( C0 A C3 )
       STA    DIRC
       LDA    #$7F
       STA    PB
       STA    MM
       LDA    #$03
       STA    PC
       LDA    #$B4      CODE MAJUSCULE
       STA    MINMAJ
       LDA    #80
       STA    C1000
       LDA    #7
       STA    C70
*************************************************************
DEBUT  LDA    #TCROFF    INT. TIMER INTERDITES
       STA    TCR
       LDA    MINMAJ
       CMP    MMP      VALEUR PRECEDENTE DE MINMAJ
       BEQ    DEBUT2
       STA    MMP
       BSR    SORTIE    SEULEMENT SI MINMAJ A CHANGE
       BSR    T4MS
DEBUT2 JSR    INIREP
*************************************************************
DEBUT3 LDA    #$FF
       STA    TIMER
* ATTENTE D'INTERRUPTION TIMER
ATT    RSP
       BCLR   7,TCR    INDICATEUR INT TIMER = 0
       BCLR   6,TCR    INT TIMER AUTORISEES
       CLI
       BSR    HORLOG   IMPULSION D'HORLOGE
ATT1   BSR    T320
       BRA    ATT1
*************************************************************
KTEST  STA    SA       ( DUREE = 50 CYCLES )
       LDX    PB
       LDA    #$FF
       STA    PB       TOUTES LES LIGNES = 1
       LDA    PA
       STX    PB       RESTAURE IMMEDIATEMENT LA LED CAPS
       TSTA
       BEQ    KT1
       BSET   KT,PC    KTEST=1
       LDA    SA
       RTS
KT1    BCLR   KT,PC    KTEST=0
       LDA    SA
       RTS
*************************************************************
* BOUCLE PRINCIPALE (INETRRUPTION TIMER)
INTTIM BCLR   7,TCR          RAZ INDICATEUR INT TIMER
       BSET   6,TCR          PAS D'INT. TIMER
       CLI                   PERMET LA RECEPTION SERIE
       JSR    SCRCLV         SCRUTATION CLAVIER
       BRCLR  7,INDIC,ATT    INDIC CODE A ENVOYER
       BSR    SORTIC         CODE ENVOYE
       BRA    ATT
*************************************************************
* SORTIE DU CODE EN SERIE  (LE CODE EST DANS A)
SORTIC LDA    CODEF
SORTIE SEI
       LDX    #8       COMPTEUR DES 8 BITS
       STX    COMPT
*START BIT
       BCLR   SD,PC
       BSR    TBIT     (8+39 MICRO-SECONDE)
* BITS DE DONNEES
SR1    LSRA
       BCS    SR2
       BCLR   SD,PC    BIT = 0
       BRA    SR3
SR2    BSET   SD,PC    BIT = 1
SR3    BSR    TBIT
       DEC    COMPT
       BNE    SR1
* STOPS BITS (3)
       BSET   SD,PC
       BSR    TBIT
       BSR    TBIT
       BCLR   7,INDIC      CODE ENVOYE
       CLI
       RTS
*************************************************************
* TEMPORISATIONS
T320   STA    SA       TEMPO 320 MICRO-SECONDE
       LDA    #5
       BRA    TTT
T4MS   STA    SA       TEMPO 4 MILLI-SECONDE
       LDA    #68
TTT    BSR    KTEST    BOUCLE 55 CYCLES
       DECA
       BNE    TTT
       LDA    SA
       RTS
*************************************************************
TBIT   JSR    KTEST
HORLOG BSET   H,PC     HORLOGE=1
       TSTA
       TSTA
       BCLR   H,PC     HORLOGE=0
       RTS
*************************************************************
* RECEPTION D'UN CODE SERIE DE 3 BITS SUR INTERRUPTION INT
INT    BSET   6,TCR    INTERDICTION INTERRUPTION TIMER
       CLRA
*VERIFICATION DU BIT DE START
       BIH    INTFIN   TEST BIT DE START
       BSR    TBIT     TEMPO 47 MICRO-S
*PRISE EN COMPTE DU BIT 0
       BIL    INT3
       ORA    #1
INT3   BSR    TBIT
*PRISE EN COMPTE DU BIT 1
       BIL    INT4
       ORA    #2
INT4   BSR    TBIT
*PRISE EN COMPTE DU BIT 2
       BIL    INT5
       ORA    #4
INT5   BSR    TBIT
       BSR    TBIT
       BSR    TBIT
       BSR    TBIT
       BSR    TBIT
       BSR    TBIT
*VERIFICATION DU STOP BIT
       BIH    CMD
INTFIN JMP    DEBUT
*************************************************************
CMD    TAX
CMD2   LDX    SAUT,X
       JMP    RST,X
*
SAUT   FCB    RST-RST  RESET LOGICIEL
       FCB    VMAJ-RST VERROUILLAGE MAJUSCULE
       FCB    VMIN,RST RETOUR EN MINUSCULE
       FCB    VT-RST   VT100
       FCB    NVT-RST  NON VT100
       FCB    TYPE-RST DEMANDE DE TYPE MIN/MAJ
********************
RST    BSR    T4MS     RESET LOGICIEL
       JMP    INIT
*
VMAJ   JSR    CPS1     VERROUILLAGE MAJUSCULE
       BRA    INTFIN
*
VMIN   JSR    CPS2     RETOUR EN MINUSCULE
       BRA    INTFIN
*
VT     BSET   5,MODE
       BRA    INTFIN
*
NVT    BCLR   5,MODE
       BRA    INTFIN
*
TYPE   CLR    MMP
       BSR    T4MS
       JMP    DEBUT
*************************************************************
*************************************************************
*  CLAVIER TO 9+  ***  21 JANVIER 1986  ***  FICHIER CL2  ***
*************************************************************
* SCRUTATION DU CLAVIER *
SCRCLV JSR    SCR
       BCS    CLVFIN
       BRCLR  6,INDIC,SC1  SAUT SI PREMIER APPUI
       CMP    CODE11
       BEQ    SC2
*************************************************************
* RETOUR SCRUTATION
CLVFIN CLR    INDIC
       BCLR   KT,PC    KTEST=0
INIREP LDA    C1000    INIT ATTENTE REPETITION
       STA    CREP1
INICAD LDA    C70      INIT CADENCE REPETITION
       STA    CREP70
       RTS
*************************************************************
* DEUXIEME SCRUTATION SI PREMIER APPUI
SC1    STA    CODE11
       JSR    T320
       JSR    SCR
       BCS    CLVFIN
       CMP    CODE11
       BNE    INIREP
*************************************************************
SC2    CMP    #TCAPS   TEST TOUCHE VERROU
       BNE    RECH
       JMP    TVERR
*************************************************************
* RECHERCHE DU CODE DANS LES TABLEAUX
RECH   LDA    $80,X    LECTURE DU TABLEAU 1
       BRCLR  5,MODE,RECH1
******
       CMP    #11      MODE VT100
       BHI    RECH1
       ADD    #$9A
       BRA    CNT2
******
RECH1  BRCLR  0,EXP,RECH2  SAUT SI CLAVIER FRANCAIS
* CLAVIER EXPORT
       BRCLR  1,SC,RECH2   SAUT SI SHIFT NON PRESSEE
       CMP    #13          TOUCHE ACC
       BNE    RE0
       LDA    #$40     @
       BRA    CNT1
RE0    CMP    #21          TOUCHE STOP
       BNE    RECH2
       LDA    #$5C     \
       BRA    CNT1
******
RECH2  CMP    #20          TOUCHES COMMUNES (1 OCTET)
       BHI    RECH3
       TAX
       LDA    TABCOM,X
       BRA    CNT2
******
RECH3  SUB    #21
       LSLA
       CMP    #7*2
       BLS    NONINV
       CMP    #27*2
       BLS    TSTVER
       BRSET  0,EXP,EXPORT
* CLAVIER FRANCAIS
       CMP    #37*2
       BLS    NONINV
       CMP    #43*2
       BHI    NONINV
       BRA    TSTVER
* CLAVIER EXPORT
EXPORT ADD    #29*2
       CMP    #66*2
       BLS    NONINV
       CMP    #75*2
       BHI    NONINV
TSTVER BRSET  7,MM,NONINV      SAUT SI NON VERROUILLAGE
       BRCLR  0,MODE,COLMAJ    SAUT EN MODE NORMAL ET VERROUILLAGE
       BRCLR  1,SC,COLMAJ      SHIFT AU REPOS = MAJ
       BRA    COLMIN           SHIFT ACTIF = MIN
NONINV BRCLR  1,SC,COLMIN
COLMAJ INCA
COLMIN TAX
       LDA    TAB2,X
CNT1   BRCLR  0,SC,CNT2        TEST DE LA TOUCHE CONTROLE
       CMP    #$3F
       BLS    CNT2
       CMP    #$7F
       BHI    CNT2
       AND    #%00011111
******
CNT2   STA    CODEF
       BSET   6,INDIC         TOUCHE PRESSEE
       BRSET  2,INDIC,ATTREP  REPETITION SI CODE DEJA ENVOYE
       BSET   7,INDIC         AUTORISATION D'ENVOI
       BSET   2,INDIC         CODE ENVOYÉ
       RTS
*************************************************************
* REPETITION AUTOMATIQUE
ATTREP TST    CREP1
       BEQ    REPET
       DEC    CREP1
REPFIN RTS
REPET  DEC    CREP70
       BNE    REPFIN
       BSET   7,INDIC
       JMP    INICAD
*************************************************************
* TOUCHE VERROUILLAGE
TVERR  BRSET   0,SC,HEXA    SAUT SI TOUCHE CNTL ENFONCEE
*************************************************************
* ACTION SUR LA TOUCHE VERROUILLAGE
CPS    BRSET  5,INDIC,CPSF   TOUCHE DEJA ENFONCEE
       BSR    CPSS
       STA    CODEF
       BSET   7,INDIC   AUTORISATION DE SORTIE DU CODE
       BSET   5,INDIC   TOUCHE CAPS ENFONCEE
CPSF   RTS
******
CPSS   TST    MM
       BPL    CPS2
CPS1   LDA    #$B4     PASSAGE EN MAJUSCULES
       LDX    #$7F
       BRA    CPS3
CPS2   LDA    #$B0     passage en minuscules
       LDX    #$FF
CPS3   STA    MINMAJ
       STA    MMP
       STX    MM
       STX    PB
       RTS
*************************************************************
HEXA   BSET   6,TCR    PAS D'INTERRUPTION TIMER
       BRCLR  1,SC,HEXA2
* FONCTIONS SPECIALES
       BSR    ATTREL
H1     JSR    SCRT     ATTENTE DE FRAPPE D'UNE TOUCHE
       BCS    H1
       LDX    $80,X
*
       CPX    #5
       BHI    H01
       STX    HEX
       BSR    ATTREL
       LDX    HEX
       JMP    CMD2     FONCTIONS UNITE CENTRALE
H01    CPX    #28
       BHI    H02
       TXA
       SUB    #24
       BMI    H02
       LSLA
       LSLA
       LSLA
       LSLA
       LSLA            A=A*32
       ADD    #40
       STA    C1000    ATTENTE REPETITION VARIABLE
       BRA    H9
H02    CPX    #46      TOUCHE V, CLAVIER VT100
       BNE    H4
       BSET   5,MODE
H4     CPX    #48      TOUCHE N, CLAVIER NON VT100
       BNE    H6
       BCLR   5,MODE
H6     CPX    #63      TOUCHE M, MIN EN SHIFT CAPS
       BNE    H7
       BSET   0,MODE
H7     CPX    #23      TOUCHE RAZ, ANNULATION MIN
       BNE    H8
       BCLR   0,MODE
H8     CPX    #58
       BHI    H9
       TXA
       SUB    #49
       BMI    H9
       LSLA
       INCA
       STA    C70      CADENCE REPETITION VARIABLE
H9     BRA    SPH3
*************************************************************
* FONCTION HEXA-DECIMALE
HEXA2  BSET   4,INDIC  FONCTION HEXA ACTIVE
HX1    BSR    ATTREL   ATTENTE RELACHEMENT DE LA TOUCHE CAPS
       BSR    SPH      ENTREE DU 1 CARACTERE HEXA
       LSLA
       LSLA
       LSLA
       LSLA
       STA    HEX
       BSR    ATTREL   ATTENTE RELACHEMENT DE LA TOUCHE HEXA
       BSR    SPH      ENTREE DU 2 CARACTERE HEXA
       ADD    HEX
       JSR    SORTIE
       BRA    HX1
**********************
ATTREL BSR    SCRT     ATTENTE DE RELACHEMENT D'UNE TOUCHE
       BCC    ATTREL
       RTS
**********************
SPH    BRCLR  0,SC,HXF    TOUCHE CNTRL RELACHEE
       BSR    SCRT
       BCS    SPH      ATTENTE FRAPPE DU CARACTERE HEXA
       LDX    #TABHEX
SPH1   CMP    0,X
       BNE    SPH2
       TXA
       AND    #$0F
       RTS
SPH2   INCX
       CPX    #TABHEX+27
       BNE    SPH1
SPH3   BSR    ATTREL   TOUCHE NON VALIDE,ATTENTE RELACHEMENT
HXF    BCLR   4,INDIC
HXFIN  JMP    DEBUT
*************************************************************
* SCRUTATION DE LA MATRICE DES TOUCHES *
*   10 LIGNES (ENTREES) ET 8 COLONNES (SORTIES)
SCRT   JSR    T4MS
SCR    BCLR   0,INDIC           1 T DETECTEE
       BCLR   1,INDIC           2 T DETECTEES
       CLR    CODE2
****** TEST DES TOUCHES SHIFT ET CONTROLE
       CLR    SC
       CLRA                     PORT B = ENTREE
       STA    DIRB
       TSTA                     * TEMPO
       TSTA                     *
       BRCLR  SHIFT,PB,SC01
       BSET   1,SC              INDICATEUR SHIFT
SC01   BRCLR  CNTRL,PB,SC02
       BSET   0,SC              INDICATEUR CONTROLE
SC02   BRCLR  FRAEXP,PB,SC03    
       DECA
SC03   STA    EXP               LECTURE TYPE DE CLAVIER
       LDA    #$FF
       STA    DIRB              PORT B EN SORTIE
******
       STA    PB
       LDA    PC
       ORA    #$03               
       STA    PC       MET LES 10 LIGNES A 1
       STA    PCC
ANTI   LDA    CLAV
       BNE    ANT
       LDA    MM
       STA    PB       RESTAURE LE VOYANT
SCERR  SEC
       RTS
ANT    STA    COL
       JSR    T320     * ANTI-REBONDS
       LDA    CLAV     *
       CMP    COL      *
       BNE    ANTI     *
*
       LDA    #$FE     MET LA PREMIERE LIGNE A 0
       STA    PB
       CLRX            COMPTEUR DE LIGNES ( 0 A 9 )
* BOUCLE EXECUTEE 10 FOIS
SCR1   LDA    CLAV
       EOR    COL      A#0 SI UNE COLONNE EST REPASSEE A 0
       BNE    SCR3
SCR2   CPX    #8
       BHI    SCFIN
       INCX
       SEC
       ROL    PB
       ROL    PCC
       LDA    PCC
       AND    #7
       STA    PC
       BRA    SCR1
* COLONNE TROUVEE. CALCUL DU NUMERO DE LA MATRICE (DE 0 A 79)
SCR3   STA    COL2     BIT(S) DE A a 1 INDIQUE COLONNE(S)
       BRSET  1,INDIC,SCR2  INTERDIT PLUS DE 2 TOUCHES
       TXA
       LSLA            A = A * 8
       LSLA
       LSLA
       STA    TEMP
       LDA    #$FF     CALCUL DU NUMERO DE LA COLONNE (0 A 7)
SCR4   INCA            DE LA PREMIERE TOUCHE
       LSR    COL2
       BCC    SCR4
       STA    TEMP2
       ADD    TEMP
       BRSET  0,INDIC,SCR5  UNE TOUCHE DEJA DETECTEE
       STA    CODE1
       BSET   0,INDIC  UNE TOUCHE DEJA DETECTEE
       BRA    SCR2
SCR5   BSET   1,INDIC  DEUX TOUCHES DETECTEES
       BRA    SCR2
**********************
SCFIN  LDA    MM
       STA    PB               RESTAURE LE VOYANT
       LDA    PC
       ORA    #3
       STA    PC               REMET LES 10 LIGNES A L'ETAT HAUT
       BRSET  1,INDIC,SCERR    ERREUR SI 2 TOUCHES PRESSEES
       LDA    CODE1
       TAX
       CLC
       RTS
*************************************************************
XXXX   EQU    *
*************************************************************
***********************************************************************
* CLAVIER TO 9+ *** 20 JANVIER 1986 *** FICHIER TAB *******************
***********************************************************************
*************     TABLEAUX DE MATRICAGE DU CLAVIER     ****************
***********************************************************************
*
* PREMIER TABLEAU DU MATRICAGE CLAVIER TO 9+
*
*-----------------------------------------
* 10 LIGNES : 0  1  2  3  4  5  6  7  8  9
*            B2 B1 B0 C1 C0 B3 B4 B5 B6 B7
*-----------------------------------------
       ORG    TAB1
*
*  PORT A     A0 A1 A2 A3 A4 A5 A6 A7
*  ------     -----------------------
       FCB    27,52,30,38,13,01,22,46    F4  4  R F ACC P1 DEL V
       FCB    26,53,31,39,68,17,19,47    F3  5  T  G =+  - INS B
       FCB    25,54,61,40,15,18,23,48    F2  6  Y  H  !  - RAZ N
       FCB    72,49,59,62,71,05,06,64     @  1  A  Q ([ P5 P6  W
       FCB    21,55,32,41,14,09,11,66  STOP  7  U  J SP P9 PE ,?
       FCB    00,56,33,42,70,16,73,75        8  I  K $&  ! }] .;
       FCB    20,57,34,43,69,65,12,76  CAPS  9  O  L  - %u ENT :/
       FCB    00,58,35,63,74,67,03,77        0  P  M  )  ^ P3 <>
       FCB    24,50,60,36,08,02,10,44    F1  2  Z  S P8 P2 P.  X
       FCB    28,51,29,37,07,04,00,45    F5  3  E  D P7 P4 P0  C
************************************************************************
* TABLES DES TOUCHES HEXA-DECIMALES
TABHEX FCB    57,25,65,73,01,09,17,33,41    0  1  2  3  4  5  6  7  8
       FCB    49,26,15,79,75,74,03,78,05    9  A  B  C  D  E  F P0 P1
       FCB    69,62,77,29,30,76,68,37,27   P2 P3 P4 P5 P6 P7 P8 P9  Q
***********************************************************************
* TABLE DES TOUCHES COMMUNES ( 1 SEUL OCTET )
TABCOM FCB    $30,$31,$32,$33,$34,$35,$36    P0  P1  P2  P3  P4  P5  P6
       FCB    $37,$38,$39,$2E,$0D,$0D,$16    P7  P8  P9  P.  PE ENT ACC
       FCB    $20,$0B,$0A,$08,$09,$1C,$00    ESP FL.H FL.B FL.G FL.D INS
***********************************************************************
* TABLE DE CONVERSION DES CODES CLAVIER (2)
       ORG    XXXX
* TOUCHES COMMUNES
TAB2   FCB    $02,$03  STOP,BREAK
       FCB    $1D,$7F  EFF,DEL
       FCB    $1E,$0C  HOME,RAZ
       FCB    $90,$95  FONCTION 1
       FCB    $91,$96  FONCTION 2
       FCB    $92,$97  FONCTION 3
       FCB    $93,$98  FONCTION 4
       FCB    $94,$99  FONCTION 5
*********************************************
* TOUCHES IDENTIQUES SUR LES 2 CLAVIERS
*         ( INVERSION EN VERROUILLAGE )
       FCB    $65,$45  E
       FCB    $72,$52  R
       FCB    $74,$54  T
       FCB    $75,$55  U
       FCB    $69,$49  I
       FCB    $6F,$4F  O
       FCB    $70,$50  P
       FCB    $73,$53  S
       FCB    $64,$44  D
       FCB    $66,$46  F
       FCB    $67,$47  G
       FCB    $68,$48  H
       FCB    $6A,$4A  J
       FCB    $6B,$4B  K
       FCB    $6C,$4C  L
       FCB    $78,$58  X
       FCB    $63,$43  C
       FCB    $76,$56  V
       FCB    $62,$42  B
       FCB    $6E,$4E  N
*********************************************
*TOUCHES SPECIFIQUES AU CLAVIER FRANCAIS
*
*         ( PAS D'INVERSION )
       FCB    $2A,$31  * 1
       FCB    $80,$32  E ACCENT AIGU  2
       FCB    $22,$33  " 3
       FCB    $27,$34  / 4
       FCB    $28,$35  ( 5
       FCB    $5F,$36  _ 6
       FCB    $81,$37  E ACCENT GRAVE  7
       FCB    $21,$38  ! 8
       FCB    $82,$39  C CEDILLE  9
       FCB    $83,$30  A ACCENT  0
*
*         ( INVERSION EN VERROUILLAGE )
       FCB    $61,$41  A
       FCB    $7A,$5A  Z
       FCB    $79,$59  Y
       FCB    $71,$51  Q
       FCB    $6D,$4D  M
       FCB    $77,$57  W
*
*         ( PAS D'INVERSION )
       FCB    $84,$25  U ACCENT   %
       FCB    $2C,$3F  , ?
       FCB    $5E,$85  ^ TREMA
       FCB    $3D,$2B  = +
       FCB    $2D,$5C  - \
       FCB    $24,$26  $ &
       FCB    $5B,$7B  [ {
       FCB    $23,$40  # @
       FCB    $5D,$7D  ] }
       FCB    $29,$86  ) NUMERO
       FCB    $3B,$2E  ; .
       FCB    $3A,$2F  : /
       FCB    $3E,$3C  > <
*********************************************
* TOUCHES SPECIFIQUES AU CLAVIER EXPORT
*
*         ( PAS D'INVERSION )
       FCB    $31,$21  1 !
       FCB    $32,$22  2 "
       FCB    $33,$87  3 PARAGRAPHE
       FCB    $34,$24  4 $
       FCB    $35,$25  5 %
       FCB    $36,$26  6 &
       FCB    $37,$2F  7 /
       FCB    $38,$28  8 (
       FCB    $39,$29  9 )
       FCB    $30,$3D  0 =
*
*         ( INVERSION EN VERROUILLAGE )
       FCB    $71,$51  Q
       FCB    $77,$57  W
       FCB    $79,$59  Y
       FCB    $61,$41  A
       FCB    $8D,$8A  O TREMA
       FCB    $7A,$5A  Z
       FCB    $8C,$89  A TREMA
       FCB    $6D,$4D  M
       FCB    $8E,$8B  U TREMA
*
*         ( PAS D'INVERSION )
       FCB    $5D,$7D  ] )
       FCB    $27,$8F  ' ACCENT GRAVE
       FCB    $2B,$2A  + *
       FCB    $3E,$3C  > <
       FCB    $5B,$7B  [ (
       FCB    $23,$5E  # ^
       FCB    $88,$3F  BETA  ?
       FCB    $2C,$3B  , ;
       FCB    $2E,$3A  . :
       FCB    $2D,$5F  - _
***********************************************************************
       END
